// Revista do Linux - Edio 39
// Curso de Java - Captulo 5
// Biblioteca.java

import java.util.*;

public class Biblioteca extends Object {
	protected Vector listaItem = null;
	// construtor
	public Biblioteca()
	{
		// iniciando a lista de itens (vetor)
		listaItem = new Vector();
	}
	// menu principal do sistema
	public boolean menuPrincipal()
	{
		int tecla = 0;
		System.out.println("MENU PRINCIPAL");
		System.out.println("==============\n");
		System.out.println("1 - Cadastro");
		System.out.println("2 - Consulta");
		System.out.println("3 - Sair");
		try {
			// lendo teclado
			tecla = System.in.read();
			// pedindo para o Java descartar o restante do buffer de leitura
			System.in.skip(100);
		} catch (Exception e) {}
		// checando a opo selecionada
		switch ((char)tecla)
		{
			case '1': {
				menuCadastro();
				break;
			}
			case '2': {
				menuConsulta();
				break;
			}
			case '3': {
				return false;
			}
		}
		return true;
        }
	// menu cadastro
	public void menuCadastro()
	{
		int tecla = 0;
		while ((char)tecla != '6')
		{
			System.out.println("CADASTRO");
			System.out.println("========\n");
			System.out.println("1 - Livro");
			System.out.println("2 - Peridico");
			System.out.println("3 - Fita VHS");
			System.out.println("4 - CD udio");
			System.out.println("5 - CD Dados");
			System.out.println("6 - Menu Principal");
			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					menuLivro();
					break;
				}
				case '2': {
					menuPeriodico();
					break;
				}
				case '3': {
					menuVHS();
					break;
				}
				case '4': {
					menuAudio();
					break;
				}
				case '5': {
					menuDado();
					break;
				}
			}
		} // fim while
	}
	// menu livro

	public void menuLivro()
	{
		int tecla = 0;

		while ((char)tecla != '4')
		{

			System.out.println("LIVRO");
			System.out.println("=====\n");
			System.out.println("1 - Inserir");
			System.out.println("2 - Alterar");
			System.out.println("3 - Remover");
			System.out.println("4 - Sair");

			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					Livro lvr = new Livro();
					lvr.inserir();
					inserir(lvr);
					lista();
					break;
				}

				case '2': {
					break;
				}
				case '3': {
					break;
				}
			}
		} // fim while
	}
	// menu peridico

	public void menuPeriodico()
	{
		int tecla = 0;

		while ((char)tecla != '4')
		{
			System.out.println("PERIDICO");
			System.out.println("=========\n");
			System.out.println("1 - Inserir");
			System.out.println("2 - Alterar");
			System.out.println("3 - Remover");
			System.out.println("4 - Sair");

			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					// Periodico per = new Periodico();
					// per.inserir();
					// inserir(per);
					break;
				}

				case '2': {
					break;
				}

				case '3': {
					break;
				}
			}
		} // fim while
	}
	// menu VHS

	public void menuVHS()
	{
		int tecla = 0;

		while ((char)tecla != '4')
		{
			System.out.println("FITA VHS");
			System.out.println("========\n");
			System.out.println("1 - Inserir");
			System.out.println("2 - Alterar");
			System.out.println("3 - Remover");
			System.out.println("4 - Sair");

			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					// VHS fita = new VHS();
					// fita.inserir();
					// inserir(fita);
					break;
				}

				case '2': {
					break;
				}

				case '3': {
					break;
				}
			}
		} // fim while
	}

	// menu udio

	public void menuAudio()
	{
		int tecla = 0;

		while ((char)tecla != '4')
		{
			System.out.println("CD UDIO");
			System.out.println("========\n");
			System.out.println("1 - Inserir");
			System.out.println("2 - Alterar");
			System.out.println("3 - Remover");
			System.out.println("4 - Sair");

			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					// Audio cda = new Audio();
					// cda.inserir();
					// inserir(cda);
					break;
				}

				case '2': {
					break;
				}

				case '3': {
					break;
				}
			}
		} // fim while
	}

	// menu Dado

	public void menuDado()
	{
		int tecla = 0;

		while ((char)tecla != '4')
		{
			System.out.println("CD DADOS");
			System.out.println("========\n");
			System.out.println("1 - Inserir");
			System.out.println("2 - Alterar");
			System.out.println("3 - Remover");
			System.out.println("4 - Sair");

			try {
				tecla = System.in.read();
				System.in.skip(100);
			} catch (Exception e) {}

			switch ((char)tecla)
			{
				case '1': {
					// Dado da = new Dado();
					// da.inserir();
					// inserir(da);
					break;
				}

				case '2': {
					break;
				}

				case '3': {
					break;
				}
			}
		} // fim while
	}

	// menu Consulta

	public void menuConsulta()
	{
		byte dados[] = new byte[255];

		System.out.println("DIGITE UM DADO PARA CONSULTA");
		System.out.println("============================\n");
		System.out.print("Dado: ");

		try {
			// lendo dados para procura
			System.in.read(dados);
		} catch(Exception e) {}

		// criando string de procura
		String procura = new String(dados);
		// retirando espaos em branco do incio e final da string estes espaos em
		// branco ficam devido ao tamanho do buffer de leitura (varivel dados[])
		procura = procura.trim();
		// transformando a string de procura para minscula
		procura = procura.toLowerCase();

		// procurar do incio at o fim do vetor de tens
		for (int i = 0; i < listaItem.size(); i++)
		{
			// pega o elemento do vetor de ndice i
			Item itm = (Item)listaItem.elementAt(i);
			// pega a descrio do item
			String desc = itm.getDescricao();
			// transforma a string em minscula para que compare minscula 
			// com minscula aumentando a chance de encontrar dados compatveis
			desc = desc.toLowerCase();

			// tenta encontrar a string 'procura' na string 'desc', se encontrar 
			// imprime o texto dentro do if
			if (desc.lastIndexOf(procura) != -1)
			{
				System.out.println("\n=========================");
				// chama o mtodo imprime do objeto se for um objeto do tipo Livro, chama 
				// o imprime do Livro, se for Peridico, chama o imprime do Peridico
				itm.imprime();
				System.out.println("=========================");
				System.out.println("Digite [ENTER] para continuar");
				System.out.println("=========================");
				try {
					// trava o teclado somente para facilitar a leitura dos dados pelo usurio
					System.in.read();
				} catch (Exception e) {}
			}
		}
	}

	// insere tens no vetor
	public void inserir(Item obj)
	{
		listaItem.addElement(obj);
	}

	// remove tens do vetor
	public void remover(Item obj)
	{
		listaItem.removeElement(obj);
	}

	// lista os tens do vetor
	public void lista()
	{
		for (int i = 0; i < listaItem.size(); i++)
		{
			Item itm = (Item)listaItem.elementAt(i);
			itm.imprime();
		}
	}

	// ATENO: este  o mtodo principal que inicia toda a aplicao!
	public static void main (String args[])
	{
		Biblioteca biblio = new Biblioteca();
		byte tecla[] = new byte[1];

		// enquanto o menu Principal retornar verdadeiro continua executando a aplicao
		while (biblio.menuPrincipal()) { }
	}
}
